// Cliente RTSP.

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.Timer;
import javax.swing.JOptionPane;

public class Reproductor{
  
  //Interfaz
  private JFrame i = new JFrame("Acceso");//Ventana acceso
  private JFrame f = new JFrame("Reproductor");//Ventana reproducción
  private JButton accesoButton = new JButton("Acceso");//botón de acceso
  private JButton playButton = new JButton("Play"); //botón play
  private JButton pauseButton = new JButton("Pause");//botón pause
  private JButton exitButton = new JButton("Exit");//botón exit
  private JPanel mainPanel = new JPanel();
  private JPanel buttonPanel = new JPanel(); //panel con los botones
  private JPanel buttonPanela = new JPanel(); //panel con el botón acceso
  public JLabel iconLabel = new JLabel();//muestra el contenido
  public ImageIcon icon;
  private static String VideoFileName; //archivo de vídeo solicitado al servidor
  protected Controlador controlador;//Controlador que gestiona las acciones de los botones de esta interfaz 
  //y realiza la comunicación con el servidor
  
   //Constructor
  public Reproductor() 
  {
	iniciarcomponentes();
	controlador=new Controlador(this);
  }

private void iniciarcomponentes()
{	//Se crea la interfaz
    
	//Frames
    f.addWindowListener(new WindowAdapter() {
       public void windowClosing(WindowEvent e) {
	 System.exit(0);
       }
    });
	
	i.addWindowListener(new WindowAdapter() {
       public void windowClosing(WindowEvent e) {
	 System.exit(0);
       }
    });

    //Botones
	buttonPanela.setLayout(new GridLayout(1,0));
    buttonPanel.setLayout(new GridLayout(1,0));
    buttonPanel.add(playButton);
    buttonPanel.add(pauseButton);
    buttonPanel.add(exitButton);
	buttonPanela.add(accesoButton);
	accesoButton.addActionListener(new accesoButtonListener());
    playButton.addActionListener(new playButtonListener());
    pauseButton.addActionListener(new pauseButtonListener());
    exitButton.addActionListener(new exitButtonListener());

    //Etiqueta de visualización de imagen
    iconLabel.setIcon(null);

    //diseño del frame
    mainPanel.setLayout(null);
    mainPanel.add(iconLabel);
    mainPanel.add(buttonPanel);
    iconLabel.setBounds(0,0,380,280);
    buttonPanel.setBounds(0,280,380,50);
	buttonPanela.setBounds(100,50,200,50);

    f.getContentPane().add(mainPanel, BorderLayout.CENTER);
    f.setSize(new Dimension(382,360));
    f.setVisible(false);
	i.getContentPane().add(buttonPanela);
	i.setSize(new Dimension(382,360));
    i.setVisible(true);

  }

  //main
  public static void main(String argv[]) throws Exception
  {
	
	//Creación de un objeto cliente
    Reproductor reproductor = new Reproductor();
	Controlador controlador = new Controlador(reproductor);
	
	if (argv.length!=0) {//Se comprueba el número de argumentos.
        System.out.println("No son necesarios argumentos");
        System.exit(-1);
    }
	  
    

    //Asignamos el puerto y la dirección IP del servidor por línea de comandos
    int RTSP_server_port = 81;
    String ServerHost = "localhost";
	InetAddress ServerIPAddr=null;
	try{
		ServerIPAddr = InetAddress.getByName(ServerHost);
	}catch(Exception e){
		System.out.println("exception: "+e);
		System.exit(-1);
	}

    //Obtenemos el nombre del archivo de vídeo requerido
    VideoFileName ="movie.mjpeg";
	controlador.set_videoFileName(VideoFileName);
	
	//Solicitamos al controlador la realización de la conexión RTSP con el servidor
	controlador.conexionRTSP(ServerIPAddr, RTSP_server_port);
	
	//Solicitamos al controlador la lectura de los procesos sospechosos enviados por el servidor
	//estos procesos son almacenados en el vector v en controlador 
	controlador.set_v(controlador.read_server_process());
	
	//Solicitamos al controlador la operación setup de RTSP
	//Es necesario realizarla antes de reproducir el contenido, pero esto no lo ve el usuario.
	controlador.setup();
  }
  
  // Acceso
  class accesoButtonListener implements ActionListener {					
	public void actionPerformed(ActionEvent e){
		i.setVisible(false);
		f.setVisible(true);
	}
  }
  
  // PLAY
  class playButtonListener implements ActionListener {					
	public void actionPerformed(ActionEvent e){
		//una vez pulsado el botón el controlador se encarga de realizar las acciones
		controlador.play();
	}
  }

  // PAUSE
  class pauseButtonListener implements ActionListener {					
    public void actionPerformed(ActionEvent e){
		//una vez pulsado el botón el controlador se encarga de realizar las acciones
		controlador.pause();
	}
  }

  // EXIT
  class exitButtonListener implements ActionListener {					
    public void actionPerformed(ActionEvent e){
		//una vez pulsado el botón el controlador se encarga de realizar las acciones
		controlador.exit();
    }
  } 
  
  //muestraMsgError
  void muestraMsgError(String string) {
                JOptionPane.showMessageDialog(null, string, "Error!", JOptionPane.ERROR_MESSAGE);

    }
}