//Vigilante

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.Timer;

public class Vigilante{
	
  //Variables SO
  private static String OS; //Sistema Operativo.
  private static String OSArch; //Arquitectura del Sistema Operativo
  private static String OSVersion; //Versión del Sistema Operativo.
  
  public Vigilante()
  {
	 //Damos valor a las variables con los datos del SO 
	 OS = System.getProperty("os.name").toLowerCase();
	 OSArch = System.getProperty("os.arch").toLowerCase();
	 OSVersion = System.getProperty("os.version").toLowerCase();
  }	
   
	//Comprobaciones SO
	public static boolean isWindows() 
    { //Comprabamos si es un SO tipo Windows
        return (OS.indexOf("win") >= 0);
    }
 
    public static boolean isMac() 
	{ //Comprobamos si es un SO tipo Mac
        return (OS.indexOf("mac") >= 0);
    }
 
    public static boolean isUnix() 
	{ //Comprobamos si es un SO tipo Unix o Linux
        return (OS.indexOf("nix") >= 0 || OS.indexOf("nux") >= 0 || OS.indexOf("aix") > 0 );
    }
 
    public static boolean isSolaris() 
	{ //Comprobamos si es un SO tipo Solaris
        return (OS.indexOf("sunos") >= 0);
    }
	
	//Que el SO tenga una arquitectura de 32 ó 64 bits solo tiene importancia en Windows 
	//al utilizar distintas versiones del ejecutable tasklist.exe para el listado de procesos.
	
	public static boolean is32bits()
	{ //Comprobamos si es un SO de 32 bits
        return (OSArch.indexOf("86") >= 0);
    }
	
	public static boolean is64bits() 
	{ //Comprobamos si es un SO de 64 bits
        return (OSArch.indexOf("64") >= 0);
    }
	
	//Vigilar 
	public boolean vigilar(Vector<String> v)
	{//Lista los procesos en ejecución y comprueba si alguno de estos procesos
	//se encuentra entre los procesos que pueden realizar una grabación del vídeo o de la pantalla.
		
		String salida = null; //Lee y almacena la salida producida por la ejecución del comando.
        String comando = null; //Almacena el comando a ejecutar en función del SO y la arquitectura.
		boolean proc = false; //Su valor es false mientras no se ejecuten procesos sospechosos de capturar el vídeo.
		
		//System.out.print("Sistema operativo: ");
		//System.out.println(OS);
		//System.out.println("Version: "+OSVersion);
        //System.out.println("Aquitectura: "+OSArch);
		if (isWindows()) 
		{
            //System.out.println("Es Windows");
			if (is32bits())
			{
				comando = "cmd /c tasklist32.exe";
				//System.out.println("Es 32 bits");
			}
			else if (is64bits())
			{
				comando = "cmd /c tasklist64.exe";
				//System.out.println("Es 64 bits");
			}
        } else if (isMac()) 
		{
			comando = "ps -e";
           // System.out.println("Es Mac");
        } else if (isUnix()) 
		{
			comando = "ps -e";
            //System.out.println("Es Unix/Linux");
        } else if (isSolaris()) 
		{
			comando = "ps -e";
            //System.out.println("Es Solaris");
        } else 
		{
            //System.out.println("Sistema operativo no reconocido!!");
        }
		
        try{
            // Ejecución del Comando
            Process proceso = Runtime.getRuntime().exec(comando);
			
			//Leemos la salida del comando
            InputStreamReader entrada = new InputStreamReader(proceso.getInputStream());
            BufferedReader stdInput = new BufferedReader(entrada);

            //Comprobamos la salida del comando.
            if((salida=stdInput.readLine().toLowerCase()) != null)
			{
            	//System.out.println("Comando ejecutado correctamente");
            	while ((salida=stdInput.readLine()) != null)
				{
					for(int i=0;i<v.size();i++){
						if (salida.indexOf(v.elementAt(i)) >= 0)
						{
							proc=true;
						}					
					}
                }
            }else
			{
            	//System.out.println("No se ha producido salida");
            }
        }catch (IOException ioe) {
            System.out.println("Excepcion: ");
            ioe.printStackTrace();
        }
		return(proc); //El valor devuelto por la función determina si hay
		//o no procesos sospechosos de capturar el vídeo.
	}
}